//+------------------------------------------------------------------+
//|                                            WUKAR_WB_Trail_v1.mq4 |
//| Orignals WUKAR.mq4 and Wheelbarrel Trailing_v1.2.mq4             |
//| are merged. Credit goes to the original authors                  |
//--------------------------------------------------------------------

#include <stdlib.mqh>
#include <stderror.mqh>
#include <WinUser32.mqh> 
extern string     TP_SL_Settings        = "";
extern bool       UseHiddenStopLoss     = true;
extern int        HiddenSL              = 100;
extern bool       use_emergency_stop_loss = true;
extern int        emergency_sl          = 200;
extern bool       UseHiddenTakeProfit   = true;
extern int        HiddenTP1             = 50;
extern string     Trailingstop_Settings = "";
extern bool       ProfitTrailing        = false;  
extern int        TrailingStop          = 35;    
extern int        TrailingStep          = 1;     
extern bool       UseSound              = false;  
extern string     NameFileSound         = "cork_pop.wav";  
extern string 	   Breakeven_Settings    = "";
extern string     BE                    = "Break even settings";
extern bool       BreakEven             = true;
extern int        BreakEvenPips         = 35;
extern double     commission            = 7;



//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void start() {
  bool result = false;
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    result = OrderSelect(i, SELECT_BY_POS);
    
    if ( OrderSymbol()==Symbol()  )
     {
      TrailingPositions();
      if (UseHiddenStopLoss)   HiddenStopLoss();
      if (UseHiddenTakeProfit) HiddenTakeProfit();  
      if (use_emergency_stop_loss)     emergency_stop_loss();
     }
  }
  return;

  /* Do not uncomment the below. It does not do anything useful except to
  open orders, so as to test, trail stop, tp aand stop loss of the two EAs 
  merged. Its a work around to test the EA is working in the tester. thats all */
  
  // OpenPosition();    
}


void TrailingPositions() {
  double pBid, pAsk, pp;

  RefreshRates();
  pp = MarketInfo(OrderSymbol(), MODE_POINT);
  double NewStop = 0 ;
  if (OrderType()==OP_BUY)
  {
    pBid = MarketInfo(OrderSymbol(), MODE_BID);
    if (BreakEven == true && OrderOpenPrice() + BreakEvenPips * pp < pBid && (OrderStopLoss() < OrderOpenPrice() || OrderStopLoss()==0)) NewStop = OrderOpenPrice() + commission * pp ;
    if (ProfitTrailing == true && pBid - OrderOpenPrice() > TrailingStop * pp && (OrderStopLoss() < pBid - (TrailingStop + TrailingStep -1)*pp || OrderStopLoss()==0)) NewStop = pBid - TrailingStop * pp ;
    if(NewStop != 0)
    {   
        if( ModifyStopLoss(NewStop) ) Print("Wheelbarrel Modified Stop Loss");
        return;
    }
  }

  if (OrderType()==OP_SELL) {
    pAsk = MarketInfo(OrderSymbol(), MODE_ASK);
    if (BreakEven == true && OrderOpenPrice() - BreakEvenPips * pp > pAsk && (OrderStopLoss() > OrderOpenPrice() || OrderStopLoss()==0)) NewStop = OrderOpenPrice() - commission * pp ;
    if (ProfitTrailing == true && OrderOpenPrice() - pAsk > TrailingStop * pp && (OrderStopLoss() > pAsk + (TrailingStop + TrailingStep -1) * pp || OrderStopLoss()==0)) NewStop = pAsk + TrailingStop * pp ;
    if(NewStop != 0)
    {   
        if( ModifyStopLoss(NewStop) ) Print("Wheelbarrel Modified Stop Loss");
        return;
    }
  }
}
    
bool ModifyStopLoss(double ldStopLoss) {
  bool fm; 
  fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE);
  if (fm && UseSound) PlaySound(NameFileSound);
  if (!fm)
  {
     int err;
     err=GetLastError();
     Print("Wheelbarrel trailing error (",err,")");
     return false;
  }
  return true;
}
//+------------------------------------------------------------------+

void HiddenTakeProfit()
{ 
  bool result = false;  
  if (OrderSymbol()==Symbol()) {
  if (OrderType() == OP_BUY &&  OrderOpenPrice()+(HiddenTP1+commission)*Point<=Bid )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(Symbol(), MODE_BID), 5, Red );
  if (OrderType() == OP_SELL &&  OrderOpenPrice()-(HiddenTP1+commission)*Point>=Ask  )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(Symbol(), MODE_ASK), 5, Red );  
  }
  return;
}
//+-------------------------------------------------------------------------------------------+
void HiddenStopLoss()
{ 
  bool result = false;
  if(OrderSymbol() == Symbol()) {
  if (OrderType() == OP_BUY &&  OrderOpenPrice()-HiddenSL*Point>=Bid )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(Symbol(), MODE_BID), 5, Red );
  if (OrderType() == OP_SELL &&  OrderOpenPrice()+HiddenSL*Point<=Ask  )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(Symbol(), MODE_ASK), 5, Red );    
  }
  return;
}

//+-------------------------------------------------------------------------------------------+
void emergency_stop_loss()
{
   int totalorders = OrdersTotal();

   for(int i=totalorders-1;i>=0;i--)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      bool result = false;

      if(OrderSymbol()==Symbol())
      {
         if(OrderType() == OP_BUY &&  OrderStopLoss()== 0.0)
            result = OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-emergency_sl*Point,OrderTakeProfit(),0,clrNONE);
         if(OrderType() == OP_SELL && OrderStopLoss()== 0.0)
            result = OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+emergency_sl*Point,OrderTakeProfit(),0,clrNONE);
      }
   }
   return;
}

//+-------------------------------------------------------------------------------------------+
void OpenPosition()
{
int ans=0;     
     if(Open[0]>Close[0]) { 
     ans = OrderSend(Symbol(),OP_BUY,0.01,Ask,25,0,0,NULL,10,Blue ); //Opening Buy        
     }
     else
     {     
     ans = OrderSend(Symbol(),OP_SELL,0.01,Bid,25,0,0,NULL,10,Blue ); //Opening Buy  
     }
     if(ans<0)
        {
         Print("Error when opening a order #",GetLastError());
         Sleep(10000);
         return;
     }       
}